The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

Public Member Functions | List of all members
stk::Fir Class Reference

STK general finite impulse response filter class. More...

`#include <Fir.h>`

Inheritance diagram for stk::Fir:

## Public Member Functions
| Fir (void)
| Default constructor creates a zero-order pass-through "filter".
| Fir (std::vector< StkFloat > &coefficients)
| Overloaded constructor which takes filter coefficients.
| ~Fir (void)
| Class destructor.
void | setCoefficients (std::vector< StkFloat > &coefficients, bool clearState=false)
| Set filter coefficients.
StkFloat | lastOut (void) const
| Return the last computed output value.
StkFloat | tick (StkFloat input)
| Input one sample to the filter and return one output.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Take a channel of the StkFrames object as inputs to the filter and replace with corresponding outputs.
StkFrames & | tick (StkFrames &iFrames, StkFrames &oFrames, unsigned int iChannel=0, unsigned int oChannel=0)
| Take a channel of the `iFrames` object as inputs to the filter and write outputs to the `oFrames` object.
Public Member Functions inherited from stk::Filter
| Filter (void)
| Class constructor.
unsigned int | channelsIn (void) const
| Return the number of input channels for the class.
unsigned int | channelsOut (void) const
| Return the number of output channels for the class.
virtual void | clear (void)
| Clears all internal states of the filter.
void | setGain (StkFloat gain)
| Set the filter gain.
StkFloat | getGain (void) const
| Return the current filter gain.
StkFloat | phaseDelay (StkFloat frequency)
| Return the filter phase delay at the specified frequency.
const StkFrames & | lastFrame (void) const
| Return an StkFrames reference to the last output sample frame.
virtual StkFrames & | tick (StkFrames &frames, unsigned int channel=0)=0
| Take a channel of the StkFrames object as inputs to the filter and replace with corresponding outputs.
Public Member Functions inherited from stk::Stk
void | ignoreSampleRateChange (bool ignore=true)
| A function to enable/disable the automatic updating of class data when the STK sample rate changes.

## Additional Inherited Members
Static Public Member Functions inherited from stk::Stk
static StkFloat | sampleRate (void)
| Static method that returns the current STK sample rate.
static void | setSampleRate (StkFloat rate)
| Static method that sets the STK sample rate.
static void | clear_alertList ()
| Static method that frees memory from alertList_.
static std::string | rawwavePath (void)
| Static method that returns the current rawwave path.
static void | setRawwavePath (std::string path)
| Static method that sets the STK rawwave path.
static void | swap16 (unsigned char *ptr)
| Static method that byte-swaps a 16-bit data type.
static void | swap32 (unsigned char *ptr)
| Static method that byte-swaps a 32-bit data type.
static void | swap64 (unsigned char *ptr)
| Static method that byte-swaps a 64-bit data type.
static void | sleep (unsigned long milliseconds)
| Static cross-platform method to sleep for a number of milliseconds.
static bool | inRange (StkFloat value, StkFloat min, StkFloat max)
| Static method to check whether a value is within a specified range.
static void | handleError (const char *message, StkError::Type type)
| Static function for error reporting and handling using c-strings.
static void | handleError (std::string message, StkError::Type type)
| Static function for error reporting and handling using c++ strings.
static void | showWarnings (bool status)
| Toggle display of WARNING and STATUS messages.
static void | printErrors (bool status)
| Toggle display of error messages before throwing exceptions.
Static Public Attributes inherited from stk::Stk
static const StkFormat | STK_SINT8
static const StkFormat | STK_SINT16
static const StkFormat | STK_SINT24
static const StkFormat | STK_SINT32
static const StkFormat | STK_FLOAT32
static const StkFormat | STK_FLOAT64
Protected Member Functions inherited from stk::Stk
| Stk (void)
| Default constructor.
virtual | ~Stk (void)
| Class destructor.
virtual void | sampleRateChanged (StkFloat newRate, StkFloat oldRate)
| This function should be implemented in subclasses that depend on the sample rate.
void | addSampleRateAlert (Stk *ptr)
| Add class pointer to list for sample rate change notification.
void | removeSampleRateAlert (Stk *ptr)
| Remove class pointer from list for sample rate change notification.
void | handleError (StkError::Type type) const
| Internal function for error reporting that assumes message in `oStream_` variable.

## Detailed Description

STK general finite impulse response filter class.

This class provides a generic digital filter structure that can be used to implement FIR filters. For filters with feedback terms, the Iir class should be used.

In particular, this class implements the standard difference equation:

y[n] = b[0]*x[n] + ... + b[nb]*x[n-nb]

The gain parameter is applied at the filter input and does not affect the coefficient values. The default gain value is 1.0. This structure results in one extra multiply per computed sample, but allows easy control of the overall filter gain.

by Perry R. Cook and Gary P. Scavone, 1995–2023.

## Constructor & Destructor Documentation

## ◆ Fir()

stk::Fir::Fir | ( | std::vector< StkFloat > & | coefficients | ) |

Overloaded constructor which takes filter coefficients.

An StkError can be thrown if the coefficient vector size is zero.

## Member Function Documentation

## ◆ setCoefficients()

void stk::Fir::setCoefficients | ( | std::vector< StkFloat > & | coefficients,
|  | bool | clearState = `false`
| ) |  |

Set filter coefficients.

An StkError can be thrown if the coefficient vector size is zero. The internal state of the filter is not cleared unless the clearState flag is `true`.

## ◆ tick() [1/2]

StkFrames & stk::Fir::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0`
| ) |  |
| inlinevirtual

Take a channel of the StkFrames object as inputs to the filter and replace with corresponding outputs.

The StkFrames argument reference is returned. The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::Filter.

101{
102#if defined(_STK_DEBUG_)
103 if ( channel >= frames.channels() ) {
104 oStream_ << "Fir::tick(): channel and StkFrames arguments are incompatible!";
105 handleError( StkError::FUNCTION_ARGUMENT );
106 }
107#endif
108
109 StkFloat *samples = &frames[channel];
110 unsigned int i, hop = frames.channels();
111 for ( unsigned int j=0; j<frames.frames(); j++, samples += hop ) {
112 inputs_[0] = gain_ * *samples;
113 *samples = 0.0;
114
115 for ( i=(unsigned int)b_.size()-1; i>0; i-- ) {
116 *samples += b_[i] * inputs_[i];
117 inputs_[i] = inputs_[i-1];
118 }
119 *samples += b_[0] * inputs_[0];
120 }
121
122 lastFrame_[0] = *(samples-hop);
123 return frames;
124}
stk::Stk::handleError
static void handleError(const char *message, StkError::Type type)
Static function for error reporting and handling using c-strings.

## ◆ tick() [2/2]

StkFrames & stk::Fir::tick | ( | StkFrames & | iFrames,
|  | StkFrames & | oFrames,
|  | unsigned int | iChannel = `0`,
|  | unsigned int | oChannel = `0`
| ) |  |
| inline

Take a channel of the `iFrames` object as inputs to the filter and write outputs to the `oFrames` object.

The `iFrames` object reference is returned. Each channel argument must be less than the number of channels in the corresponding StkFrames argument (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

127{
128#if defined(_STK_DEBUG_)
129 if ( iChannel >= iFrames.channels() || oChannel >= oFrames.channels() ) {
130 oStream_ << "Fir::tick(): channel and StkFrames arguments are incompatible!";
131 handleError( StkError::FUNCTION_ARGUMENT );
132 }
133#endif
134
135 StkFloat *iSamples = &iFrames[iChannel];
136 StkFloat *oSamples = &oFrames[oChannel];
137 unsigned int i, iHop = iFrames.channels(), oHop = oFrames.channels();
138 for ( unsigned int j=0; j<iFrames.frames(); j++, iSamples += iHop, oSamples += oHop ) {
139 inputs_[0] = gain_ * *iSamples;
140 *oSamples = 0.0;
141
142 for ( i=(unsigned int)b_.size()-1; i>0; i-- ) {
143 *oSamples += b_[i] * inputs_[i];
144 inputs_[i] = inputs_[i-1];
145 }
146 *oSamples += b_[0] * inputs_[0];
147 }
148
149 lastFrame_[0] = *(oSamples-oHop);
150 return iFrames;
151}

The documentation for this class was generated from the following file:

- Fir.h

The Synthesis ToolKit in C++ (STK)
©1995--2023 Perry R. Cook and Gary P. Scavone. All Rights Reserved.